
/**
 * @author Gevater_Tod4711
 * @version 1.0
 */
public abstract class Generator {
	
	public static String generateAll(String variable) throws IllegalArgumentException {
		return generateGetter(variable) + "\n" + generateSetter(variable);
	}
	public static String generateGetter(String variable) throws IllegalArgumentException {
		String[] parts = variable.split(" ");
		String type;
		String modifiers = "public ";
		String name;
		String methodName;
		String spaces = "";
		int initialisation = parts.length;
		try {
			for (int i = 0; variable.substring(i, i+1).equals(" "); i++) {
				spaces += " ";
			}
			for (int i = 0; i < parts.length; i++) {
				if (parts[i].equals("=")) {
					initialisation = i;
				}
			}
			for (int i = 0; i < initialisation - 2; i++) {
				if (!parts[i].equals("private") && !parts[i].equals("protected") && !parts[i].equals("public") && !parts[i].equals("final") && !parts[i].equals("")) {
					modifiers += parts[i] + " ";
				}
			}
			type = parts[initialisation - 2];
			name = parts[initialisation - 1];
			if (name.substring(name.length()-1).equals(";")) {
				name = name.substring(0, name.length() - 1);
			}
			methodName = "get" + name.substring(0, 1).toUpperCase() + name.substring(1);
		}
		catch (Exception e) {
			throw new IllegalArgumentException("The given String (" + variable + ") is not valid", e);
		}
		return spaces + modifiers + type + " " + methodName + "() {\n" + spaces + "    return " + name + ";\n" + spaces + "}";
	}
	public static String generateSetter(String variable) throws IllegalArgumentException {
		String[] parts = variable.split(" ");
		String type;
		String modifiers = "public ";
		String name;
		String methodName;
		String spaces = "";
		boolean declareStatic = false;
		int initialisation = parts.length;
		try {
			for (int i = 0; variable.substring(i, i+1).equals(" "); i++) {
				spaces += " ";
			}
			for (int i = 0; i < parts.length; i++) {
				if (parts[i].equals("=")) {
					initialisation = i;
				}
			}
			for (int i = 0; i < initialisation - 2; i++) {
				if (!parts[i].equals("private") && !parts[i].equals("protected") && !parts[i].equals("public") && !parts[i].equals("final") && !parts[i].equals("")) {
					modifiers += parts[i] + " ";
				}
			}
			type = parts[initialisation - 2];
			name = parts[initialisation - 1];
			if (name.substring(name.length()-1).equals(";")) {
				name = name.substring(0, name.length() - 1);
			}
			methodName = "set" + name.substring(0, 1).toUpperCase() + name.substring(1);
		}
		catch (Exception e) {
			throw new IllegalArgumentException("The given String is not valid", e);
		}
		if (declareStatic) {
			return spaces + modifiers + "void " + methodName + "(" + type + " " + name.charAt(0) + ") {\n" + spaces + "    " + name + " = " + name.charAt(0) + ";\n" + spaces + "}";
		}
		else {
			return spaces + modifiers + "void " + methodName + "(" + type + " " + name + ") {\n" + spaces + "    this." + name + " = " + name + ";\n" + spaces + "}";
		}
	}
}