import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Font;
import javax.swing.JScrollPane;
import java.awt.Insets;
import javax.swing.JTextArea;
import javax.swing.JCheckBox;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Component;

public class GeneratorFrame extends JFrame {
	
	private static final long serialVersionUID = 8483248766944927973L;
	
	private JPanel contentPane;
	private JTextArea textArea;
	private JTextArea textArea_1;
	private JCheckBox chckbxGenerateGetters;
	private JCheckBox chckbxGenerateSetters;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GeneratorFrame frame = new GeneratorFrame();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public GeneratorFrame() {
		setResizable(false);
		setTitle("Getter- / Setter - Generator");
		setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		setBounds(100, 100, 400, 450);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		GridBagLayout gbl_contentPane = new GridBagLayout();
		gbl_contentPane.columnWidths = new int[]{0, 0, 0, 0};
		gbl_contentPane.rowHeights = new int[]{35, 10, 25, 100, 25, 25, 100, 0};
		gbl_contentPane.columnWeights = new double[]{0.0, 0.0, 1.0, Double.MIN_VALUE};
		gbl_contentPane.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		contentPane.setLayout(gbl_contentPane);
		
		JLabel lblGetterSetterGenerator = new JLabel("Getter- / Setter - Generator");
		lblGetterSetterGenerator.setFont(new Font("Tahoma", Font.PLAIN, 16));
		GridBagConstraints gbc_lblGetterSetterGenerator = new GridBagConstraints();
		gbc_lblGetterSetterGenerator.gridwidth = 3;
		gbc_lblGetterSetterGenerator.insets = new Insets(0, 0, 5, 0);
		gbc_lblGetterSetterGenerator.gridx = 0;
		gbc_lblGetterSetterGenerator.gridy = 0;
		contentPane.add(lblGetterSetterGenerator, gbc_lblGetterSetterGenerator);
		
		JLabel lblVariables = new JLabel("Variables:");
		lblVariables.setFont(new Font("Tahoma", Font.PLAIN, 12));
		GridBagConstraints gbc_lblVariables = new GridBagConstraints();
		gbc_lblVariables.gridwidth = 3;
		gbc_lblVariables.anchor = GridBagConstraints.WEST;
		gbc_lblVariables.insets = new Insets(0, 0, 5, 0);
		gbc_lblVariables.gridx = 0;
		gbc_lblVariables.gridy = 2;
		contentPane.add(lblVariables, gbc_lblVariables);
		
		JScrollPane scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.gridwidth = 3;
		gbc_scrollPane.insets = new Insets(0, 0, 5, 0);
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 3;
		contentPane.add(scrollPane, gbc_scrollPane);
		
		textArea = new JTextArea();
		textArea.addKeyListener(new KeyAdapter() {
			@Override
			public void keyReleased(KeyEvent arg0) {
				generateMethods();
			}
		});
		scrollPane.setViewportView(textArea);
		
		chckbxGenerateGetters = new JCheckBox("Generate Getters");
		chckbxGenerateGetters.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				generateMethods();
			}
		});
		chckbxGenerateGetters.setSelected(true);
		GridBagConstraints gbc_chckbxGenerateGetters = new GridBagConstraints();
		gbc_chckbxGenerateGetters.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxGenerateGetters.gridx = 0;
		gbc_chckbxGenerateGetters.gridy = 4;
		contentPane.add(chckbxGenerateGetters, gbc_chckbxGenerateGetters);
		
		chckbxGenerateSetters = new JCheckBox("Generate Setters");
		chckbxGenerateSetters.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				generateMethods();
			}
		});
		chckbxGenerateSetters.setSelected(true);
		GridBagConstraints gbc_chckbxGenerateSetters = new GridBagConstraints();
		gbc_chckbxGenerateSetters.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxGenerateSetters.gridx = 1;
		gbc_chckbxGenerateSetters.gridy = 4;
		contentPane.add(chckbxGenerateSetters, gbc_chckbxGenerateSetters);
		
		JLabel lblGetterSetterMethods = new JLabel("Getter - / Setter - Methods:");
		lblGetterSetterMethods.setFont(new Font("Tahoma", Font.PLAIN, 12));
		GridBagConstraints gbc_lblGetterSetterMethods = new GridBagConstraints();
		gbc_lblGetterSetterMethods.gridwidth = 3;
		gbc_lblGetterSetterMethods.anchor = GridBagConstraints.WEST;
		gbc_lblGetterSetterMethods.insets = new Insets(0, 0, 5, 0);
		gbc_lblGetterSetterMethods.gridx = 0;
		gbc_lblGetterSetterMethods.gridy = 5;
		contentPane.add(lblGetterSetterMethods, gbc_lblGetterSetterMethods);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		GridBagConstraints gbc_scrollPane_1 = new GridBagConstraints();
		gbc_scrollPane_1.gridwidth = 3;
		gbc_scrollPane_1.fill = GridBagConstraints.BOTH;
		gbc_scrollPane_1.gridx = 0;
		gbc_scrollPane_1.gridy = 6;
		contentPane.add(scrollPane_1, gbc_scrollPane_1);
		
		textArea_1 = new JTextArea();
		textArea_1.setEditable(false);
		scrollPane_1.setViewportView(textArea_1);
	}
	
	private void generateMethods() {
		String[] input = textArea.getText().split("\n");
		String output = "";
		try {
			for (int i = 0; i < input.length; i++) {
				if (input[i] != null && !input[i].equals("")) {
					if (chckbxGenerateGetters.isSelected() && chckbxGenerateSetters.isSelected()) {
						output += Generator.generateAll(input[i]) + (i == input.length-1 ? "" : "\n\n");
					}
					else if (chckbxGenerateGetters.isSelected()) {
						output += Generator.generateGetter(input[i]) + (i == input.length-1 ? "" : "\n\n");
					}
					else if (chckbxGenerateSetters.isSelected()) {
						output += Generator.generateSetter(input[i]) + (i == input.length-1 ? "" : "\n\n");
					}
				}
			}
			textArea_1.setText(output);
		}
		catch (IllegalArgumentException iae) {
			textArea_1.setText("Invalid variables");
		}
	}
}